/*
    Aufgabe3) Bäume

    In der Klasse IntTree haben Sie eine Baumimplementierung gegeben, die einen sortierten Binärbaum abbildet.
    Jede Veränderung des Baumes durch eine Methode muss gewährleisten, dass dieser sortiert bleibt.
    Dazu sollen Sie folgende zusätzliche Methoden implementieren:

    - countNodes:       Liefert die Anzahl der Knoten im Baum zurück. Wird ohne Parameter auf dem Baum aufgerufen.
    - height:           Liefert die Höhe des Baumes zurück. Der leere Baum hat die Höhe 0. Hat der Baum nur einen
                        Knoten (Wurzel), dann hat er die Höhe 1. Mit jeder zusätzlichen Stufe von Nachfolgern erhöht
                        sich die Höhe um 1. Der nachfolgend abgebildete Baum hat die Höhe 4.
                                                 12
                                              /      \
                                            4         15
                                          /   \      /
                                         1     6   13
                                              /      \
                                             5        14
    Bitte verwenden Sie damit die Tests richtig funktionieren für die print-Methoden die angegebene Ausgabe ohne zusätzliche Formatierungen !
    - printLeaves:      Diese Methode gibt die Elemente der Blätterknoten aus, wobei das linke Blatt immer vor dem rechten Blatt ausgegeben wird.
                        Verwenden Sie an entsprechender Stelle für die Ausgabe -> System.out.println(this.elem);
    - printInOrderUp:   Diese Methode gibt alle Elemente in aufsteigender Reihenfolge aus.
                        Verwenden Sie an entsprechender Stelle für die Ausgabe -> System.out.println(this.elem);
    - printInOrderUpSub:Diese Methode gibt alle Elemente eines Teilbaums in aufsteigender Reihenfolge aus. Dazu wird der
                        Methode ein Element übergeben, welches dem Wurzelknoten des Teilbaums entspricht.
                        Nun wird der komplette Teilbaum inklusive Wurzel ausgegben.
                        Verwenden Sie an entsprechender Stelle für die Ausgabe -> System.out.println(this.elem);
    - printInOrderDown: Diese Methode gibt alle Elemente in absteigender Reihenfolge aus.
                        Verwenden Sie an entsprechender Stelle für die Ausgabe -> System.out.println(this.elem);
    - printPostOrder:   Diese Methode gibt alle Elemente in der sogenannten Post-Order aus.
                        Die Post-Order für den oben abgebildeten Baum ergibt folgende Reihenfolge (1,5,6,4,14,13,15,12)
                        Verwenden Sie an entsprechender Stelle für die Ausgabe -> System.out.println(this.elem);
    - printPreOrder:    Diese Methode gibt alle Elemente in der sogenannten Pre-Order aus.
                        Die Pre-Order für den oben abgebildeten Baum ergibt folgende Reihenfolge (12,4,1,6,5,15,13,14)
                        Verwenden Sie an entsprechender Stelle für die Ausgabe -> System.out.println(this.elem);
    - printLevelOrder:  Diese Methode gibt alle Elemente in der sogenannten Level-Order aus.
                        Die Level-Order bildet den Baum Level für Level ab. Der oben stehende Baum produziert folgende
                        Ausgabe:       12
                                       4 15
                                       1 6 13
                                       5 14
                        Verwenden Sie an entsprechender Stelle für die Ausgabe -> System.out.println(this.elem + " ");
                        Nach jedem Element folgt ein Leerzeichen, auch nach dem letzten Element einer Zeile!

    [fortgeschritten]
    Implementieren Sie zusätzlich eine iterative Version "printInOrderUpIter", "printPostOrderIter" und "printLevelOrderIter" der
    oben beschriebenen Methoden.

    Zusatzfragen:
    1. Falls die Elemente beim Einfügen in den Baum in ungünstiger Reihenfolge auftreten könnte im schlimmsten Fall ein
       entarteter Baum entsthen. Wie würde dieser für unser Beispiel in der Angabe aussehen?
*/

class IntTree {

    private class Node {

        int elem;
        Node left = null;
        Node right = null;

        Node(int elem) {
            this.elem = elem;
        }

        void add(int elem) {
            if (elem < this.elem) {
                if (this.left == null) {
                    this.left = new Node(elem);
                } else {
                    this.left.add(elem);
                }
            } else {
                if (this.right == null) {
                    this.right = new Node(elem);
                } else {
                    this.right.add(elem);
                }
            }
        }

        int countNodes() {
            /* TODO: add code here */
        }

        int height() {
            /* TODO: add code here */
        }

        void printLeaves() {
            /* TODO: add code here */
        }

        void printInOrderUp() {
            /* TODO: add code here */
        }

        void printInOrderUpSub(int elem) {
            /* TODO: add code here */
        }

        void printInOrderDown() {
            /* TODO: add code here */
        }

        void printPostOrder() {
            /* TODO: add code here */
        }

        void printPreOrder() {
            /* TODO: add code here */
        }

        void printLevelOrder(int level) {
            /* TODO: add code here */
        }
    }

    private Node root = null;

    public void add(int elem) {
        if (empty()) {
            this.root = new Node(elem);
        } else {
            this.root.add(elem);
        }
    }

    public boolean empty() {
        return this.root == null;
    }

    public int countNodes() {
        if (this.root == null) {
            return 0;
        }
        return this.root.countNodes();
    }

    public int height() {
        if (this.root == null) {
            return 0;
        }
        return this.root.height();
    }

    public void printLeaves() {
        if (this.root != null) {
            this.root.printLeaves();
        }
    }

    public void printInOrderUp() {
        if (this.root != null) {
            this.root.printInOrderUp();
        }
    }

    public void printInOrderUpSub(int elem) {
        if (this.root != null) {
            this.root.printInOrderUpSub(elem);
        }
    }

    public void printInOrderDown() {
        if (this.root != null) {
            this.root.printInOrderDown();
        }
    }

    public void printPostOrder(){
        if(this.root != null){
            this.root.printPostOrder();
        }
    }

    public void printPreOrder(){
        if(this.root != null){
            this.root.printPreOrder();
        }
    }

    public void printLevelOrder(){
        /* TODO: add code here */
    }
}

public class Aufgabe3 {

    // just for testing ...
    public static void main(String[] args) {
        // Implementierung von main wird nicht beurteilt

        // Entfernen Sie zum Testen die folgenden Kommentarzeichen.
        /*
        int [] mytestarray = new int[]{12,4,6,15,1,13,5,14};
        IntTree myTree = new IntTree();
        for(int i = 0; i < mytestarray.length; i++){
            myTree.add(mytestarray[i]);
        }
        System.out.println("Node Count*******");
        System.out.println(myTree.countNodes());
        System.out.println("Height***********");
        System.out.println(myTree.height());
        System.out.println("Leaves***********");
        myTree.printLeaves();
        System.out.println("InOrderDown******");
        myTree.printInOrderDown();
        System.out.println("InOrderUp********");
        myTree.printInOrderUp();
        System.out.println("InOrderSubUp*****");
        myTree.printInOrderUpSub(4);
        System.out.println("PostOrder********");
        myTree.printPostOrder();
        System.out.println("PreOrder*********");
        myTree.printPreOrder();
        System.out.println("LevelOrder*******");
        myTree.printLevelOrder();
        */
    }
}
