import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.CoreMatchers.nullValue;
import static org.junit.Assert.assertThat;

public class Aufgabe5Test {

    @Rule
    public Timeout globalTimeout = new Timeout(200);

    @Test
    public void testCountColors() throws Exception {

        Box box = new Box("white",5,new Box("red",3,new Box("blue",2,new Box("red",1,null))));

        assertThat("countColors failed", box.countColors().get("blue"), is(1));
        assertThat("countColors failed", box.countColors().get("red"), is(2));
        assertThat("countColors failed", box.countColors().get("white"), is(1));
        assertThat("countColors failed", box.countColors().get("black"), is(nullValue()));
        assertThat("countColors failed", box.countColors().get(""), is(nullValue()));

        box = new Box("white",5);

        assertThat("countColors failed", box.countColors().get("white"), is(1));
        assertThat("countColors failed", box.countColors().get("red"), is(nullValue()));
        assertThat("countColors failed", box.countColors().get(""), is(nullValue()));

    }

    @Test
    public void testHasColors() throws Exception {

        Box box = new Box("white",5,new Box("red",3,new Box("blue",2,new Box("red",1,null))));

        assertThat("hasColor failed", box.hasColor("blue"), is(true));
        assertThat("hasColor failed", box.hasColor("red"), is(true));
        assertThat("hasColor failed", box.hasColor("white"), is(true));
        assertThat("hasColor failed", box.hasColor("yellow"), is(false));
        assertThat("hasColor failed", box.hasColor(""), is(false));

        box = new Box("black",5);
        assertThat("hasColor failed", box.hasColor("black"), is(true));
        assertThat("hasColor failed", box.hasColor("red"), is(false));

    }

    @Test
    public void testIsWellNested() throws Exception {

        Box box = new Box("white",5,new Box("red",3,new Box("blue",2,new Box("red",1,null))));
        assertThat("isWellNested failed", box.isWellNested(), is(true));

        box = new Box("white",2,new Box("red",3,new Box("blue",2,new Box("red",1,null))));
        assertThat("isWellNested failed", box.isWellNested(), is(false));

        box = new Box("white",3,new Box("red",3,new Box("blue",2,new Box("red",1,null))));
        assertThat("isWellNested failed", box.isWellNested(), is(false));

        box = new Box("white",3,new Box("red",2,new Box("blue",1,new Box("red",1,null))));
        assertThat("isWellNested failed", box.isWellNested(), is(false));

        box = new Box("white",5,new Box("red",3,new Box("blue",2,new Box("red",6,null))));
        assertThat("isWellNested failed", box.isWellNested(), is(false));

        box = new Box("black",5);
        assertThat("isWellNested failed", box.isWellNested(), is(true));

    }

    @Test
    public void testIsSortedDescending() throws Exception {

        Box box = new Box("white",5,new Box("red",3,new Box("blue",2,new Box("red",1,null))));
        assertThat("isSortedDescending failed", Aufgabe5.isSortedDescending(box), is(true));

        box = new Box("white",2,new Box("red",3,new Box("blue",2,new Box("red",1,null))));
        assertThat("isSortedDescending failed", Aufgabe5.isSortedDescending(box), is(false));

        box = new Box("white",5,new Box("red",3,new Box("blue",2,new Box("red",6,null))));
        assertThat("isSortedDescending failed", Aufgabe5.isSortedDescending(box), is(false));

        box = new Box("black",5);
        assertThat("isSortedDescending failed", Aufgabe5.isSortedDescending(box), is(true));

    }

}